package com.jamesquinley.DelegationServices;
import com.mongodb.*;
import com.mongodb.client.MongoClient;
import com.mongodb.client.MongoClients;
import com.mongodb.client.MongoCollection;
import com.mongodb.client.MongoDatabase;
import org.bson.Document;

import javax.print.Doc;
import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.Executors;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.TimeUnit;

import static com.mongodb.client.model.Filters.eq;
import static java.util.concurrent.TimeUnit.SECONDS;

public class delegationServices {
    static ConnectionString scReadconnectionString;
    static MongoClientSettings scReadsettings;
    static MongoClient dClient;
    static MongoDatabase dClientDatabase;
    static MongoCollection<Document> dCollection;
    static MongoDatabase RGFilterDB;
    static MongoCollection<Document> RGFilter;
    static Document Lrequest = null;
    public static void connectionInit() {

            scReadconnectionString = new ConnectionString("mongodb+srv://edgenetworknode:yUiWfJBYCGwdRayj@matchnethop.hgxv0xd.mongodb.net/?retryWrites=true&w=majority");
            //connects to database that production clients can use
            System.out.println("This is a production server build (and will only work on that type)");
            scReadsettings = MongoClientSettings.builder()
                    .applyConnectionString(scReadconnectionString)
                    .applyToSocketSettings(builder ->
                            builder.connectTimeout(5, SECONDS)
                                    .readTimeout(6, SECONDS))
                    .build();
            dClient = MongoClients.create(scReadsettings);
            dClientDatabase = dClient.getDatabase("edgecomm");
            dCollection = dClientDatabase.getCollection("nettranslate");
    }
    static ConnectionString AccountCon = new ConnectionString("mongodb://matchmakingbackend:erhijew983ruefeyf@192.168.1.5:27017/gameservices?retryWrites=true&w=majority");
    //mongodb://localhost:27017
    //erhijew983ruefeyf
    //mongodb://accountserver:x2sJ8Qu0VVMifNLX@192.168.1.5:27017/account?retryWrites=true&w=majority
    static MongoClientSettings AccountSettings = MongoClientSettings.builder()
            .applyConnectionString(AccountCon)
            .applyToSocketSettings(builder ->
                    builder.connectTimeout(5, SECONDS)
                            .readTimeout(6, SECONDS))
            .build();
    static MongoClient accountGetClient = MongoClients.create(AccountSettings);
    static MongoDatabase gameServices = accountGetClient.getDatabase("gameservices");
    static MongoCollection<Document> lobbyIndex = gameServices.getCollection("matchmaking");
    static  MongoDatabase database = accountGetClient.getDatabase("service");
    static MongoCollection<Document> servicesStatus = database.getCollection("config");
    static int RequestR;
    //still need to config

    /*
    Request (Simple) Index

    1 - Get all active lobbies
    2 - Return All lobbies request
    3 - Submit Lobby for posting
    4 - Return posting and lobby key
    5 - Submit Lobby de-listing request
    6 - Return de-lisitng result (return status is deleted:true;false)
     */

    public static void delegationProcesser() {
        Document Filter;
        Object ClientID = null;
        try {
            ClientID = Lrequest.get("_id");
        } catch (Exception exrp) {
            System.out.println("This request has opted out of CID.");
        }
        int request = (int) Lrequest.get("type");
                if (request == 1 || request == 3) {
                    if (request ==1 ) {
                        List<String> lobbyNameList = new ArrayList<>();
                        List<String> lobbyIPList = new ArrayList<>();
                        List<String> lobbyKeyList = new ArrayList<>();
                        BasicDBObject requestModifier = new BasicDBObject();
                        requestModifier.append("_id", ClientID);
                        BasicDBObject updateQuery = new BasicDBObject();
                        BasicDBObject nameUpdate = new BasicDBObject();
                        BasicDBObject ipUpdate = new BasicDBObject();
                        BasicDBObject statusUpdate = new BasicDBObject();
                        BasicDBObject lobbyNum = new BasicDBObject();


                        Document index = new Document();
                        index = lobbyIndex.find(eq("indexref", "ocs_matchmakingidx")).first();
                        lobbyNameList = (List<String>) index.get("LobbyName");
                        lobbyIPList = (List<String>) index.get("LobbyIP");
                        //lobbyKeyList = (List<String>) index.get("LobbyPrivateKey");
                        System.out.println(lobbyNameList);
                        System.out.println(lobbyIPList);
                        if (lobbyNameList.stream().count() -1 ==0) {
                            nameUpdate.append("$set",
                                    new BasicDBObject().append("lobbies", "No lobbies are available..."));
                            updateQuery.append("$set",
                                    new BasicDBObject().append("type", 2));
                            lobbyNum.append("$set",
                                    new BasicDBObject().append("LobbyCount", 0));
                            statusUpdate.append("$set",
                                    new BasicDBObject().append("status", true));
                            dCollection.updateOne(requestModifier, updateQuery);
                            dCollection.updateOne(requestModifier,nameUpdate);
                            dCollection.updateOne(requestModifier,lobbyNum);
                            dCollection.updateOne(requestModifier, statusUpdate);
                            DeleteTargetRequestByID(ClientID);
                        } else {
                            updateQuery.append("$set",
                                    new BasicDBObject().append("type", 2));
                            nameUpdate.append("$set",
                                    new BasicDBObject().append("lobbies", lobbyNameList));
                            ipUpdate.append("$set",
                                    new BasicDBObject().append("ip", lobbyIPList));
                            lobbyNum.append("$set",
                                    new BasicDBObject().append("LobbyCount", (int) lobbyNameList.stream().count() -1));
                            statusUpdate.append("$set",
                                    new BasicDBObject().append("status", true));
                            dCollection.updateOne(requestModifier, updateQuery);
                            dCollection.updateOne(requestModifier, nameUpdate);
                            dCollection.updateOne(requestModifier, ipUpdate);
                            dCollection.updateOne(requestModifier,lobbyNum);
                            dCollection.updateOne(requestModifier, statusUpdate);
                            DeleteTargetRequestByID(ClientID);
                        }
                    }
                }
        }
    public static void DeleteTargetRequestByID (Object ID)
    {
        final ScheduledExecutorService scheduler = Executors.newScheduledThreadPool(1);
        final Runnable runnable = new Runnable() {
            int countdownStarter = 5;
            public void run() {
                countdownStarter--;
                if (countdownStarter <= 0) {
                    countdownStarter = 5;
                    BasicDBObject searchQuery = new BasicDBObject();
                    searchQuery.append("_id", ID);
                    dCollection.deleteMany(searchQuery);
                    System.out.println("Flushed a targeted request (CID) from the server");
                    scheduler.shutdown();
                }
            }
        };
        scheduler.scheduleAtFixedRate(runnable, 0, 1, TimeUnit.SECONDS);
    }
    public static void init() {
        BasicDBObject searchQueryT = new BasicDBObject();
        BasicDBObject searchQueryF = new BasicDBObject();
        BasicDBObject LobbyIndex = new BasicDBObject();
        searchQueryT.append("status", true);
        searchQueryF.append("status", false);
        LobbyIndex.append("indexref", "ocs_matchmakingidx");
        dCollection.deleteMany(searchQueryT);
        dCollection.deleteMany(searchQueryF);
        System.out.println("Flushed NetJump Server");
        lobbyIndex.deleteMany(LobbyIndex);
        System.out.println("Flushed Matchmaking Index Server");
        System.out.println("Creating Matchmaking Storage Index...");
        Document lobbyIndexTemplate = new Document();
        List<String> lobbyNameList = new ArrayList<>();
        List<String> lobbyIPList = new ArrayList<>();
        List<String> lobbyKeyList = new ArrayList<>();
        lobbyNameList.add("startatone");
        lobbyIPList.add("startatone");
        lobbyKeyList.add("startatone");
        lobbyIndexTemplate.append("LobbyName",lobbyNameList);
        lobbyIndexTemplate.append("LobbyIP", lobbyIPList);
        lobbyIndexTemplate.append("LobbyPrivateKey",lobbyKeyList);
        lobbyIndexTemplate.append("indexref", "ocs_matchmakingidx");
        lobbyIndex.insertOne(lobbyIndexTemplate);


    }
    public static void matchmakingService() {
        Lrequest = dCollection.find(eq("status", false)).first();
        if (!(Lrequest == null)) {
                      delegationProcesser();
        }


    }
    
}
